#!/usr/bin/python
# encoding: iso-8859-1
"""
 pyDisspam
 
 A rewrite of the disspam project (http://freshmeat.net/projects/disspam/)
 in python, with slight differences:
  - pyDisspam does not support SpamAssasin
  - pyDisspam does support apop authentication as well as SSL access to accounts
  - pyDisspam can be run as a daemon
  - pyDisspam can match subjects and sender addresses against regular expressions
 
 At this point I would like to thank Mina Naguib, the developer of the orginal disspam project,
 who inspired me to write this script.


 Copyright (C) 2006  Phillip Berndt

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

 The DTD and the sample configuration file 
"""
import poplib, re, sys, socket, xml.dom.minidom, string, base64, time, os, libxml2, datetime, email.Header

# Load the path of the configuration file
if len(sys.argv) == 1:
	configFile = "disspam.xml"
elif len(sys.argv) > 2 or sys.argv[1] == "-h" or sys.argv[1] == "--help":
	print "pyDisspam"
	print " Usage:"
	print "  ./disspam.py [configurationfile]"
	print " The config file defaults to ./disspam.xml"
	print
	sys.exit(0)
else:
	configFile = sys.argv[1] 

# Validate configuration against DTD file
def errHandler(arg, msg, severity, reserved):
	print "The configuration is invalid: %s" % (msg)
	sys.exit(1)
try:
	xmlFile = libxml2.createFileParserCtxt(configFile)
	xmlFile.setErrorHandler(errHandler, 0)
	xmlFile.validate(1)
	xmlFile.parseDocument()
except:
	print "Error while loading configuration file"
	sys.exit(1)
if not xmlFile.isValid():
	sys.exit(0)
del errHandler, xmlFile

# Load configuration
try:
	configFile = xml.dom.minidom.parse(configFile).lastChild
	options = configFile.getElementsByTagName("config")[0]
	rbls = [ element.firstChild.nodeValue for element in options.getElementsByTagName("rbl")[0].getElementsByTagName("server")]
	try:
		keywords = [ (element.getAttribute("match"), element.firstChild.nodeValue) for element in options.getElementsByTagName("keywords")[0].getElementsByTagName("keyword")]
	except:
		keywords = []

	daemonize = options.getElementsByTagName("daemonize")
	daemonInterval = False
	if len(daemonize) > 0:
		daemonInterval = int(daemonize[0].getAttribute("interval"))
		if(os.fork() != 0):
			sys.exit(0)
	deleteMessages = (len(options.getElementsByTagName("delete")) != 0)

	log = options.getElementsByTagName("log")
	logMail = False
	if len(log) > 0:
		logMail = log[0].getAttribute("email")
		logFileName = log[0].getAttribute("file")
		logFile = open(logFileName, "a")
		logVerbosity = int(log[0].getAttribute("verbosity"))
		def log(text, importance = 1):
			if logVerbosity > importance: return
			logFile.write(text + "\n")
			logFile.flush();
	elif(daemonInterval != False):
		def log(text, reserved = 1):
			pass
	else:
		def log(text, reserved = 1):
			print text
except(SystemExit):
	sys.exit(0)
except:
	print sys.exc_info()
	print "Failed to load configuration from disspam.xml: %s" % (sys.exc_info()[1])
	sys.exit(1)
log("pyDisspam started")

# If daemonized, fork every "interval" seconds
if daemonInterval != False:
	while True:
		# Send logile
		if logMail:
			fileAge = datetime.datetime.fromtimestamp(os.fstat(logFile.fileno())[8])
			now = datetime.datetime.now()
			if (now - fileAge).days > 0:
				logFile.close()
				fileData = open(logFileName, "r").read()
				if len(fileData) > 0:
					fileData = "PyDisspam's actions of today:\n\n" + fileData
					os.popen("mail -s 'PyDisspam daily log' %s &>/dev/null" % logMail, "w").write(fileData)
				logFile = open(logFileName, "w")
		
		# Execute daemon
		if os.fork() == 0:
			break
		time.sleep(daemonInterval)

# For each email account
accounts = configFile.getElementsByTagName("accounts")[0].getElementsByTagName("account")
def getAccountInfo(account, info):
	infoField = account.getElementsByTagName(info)[0]
	
	if info == "password" and infoField.hasAttribute("enc"):
		return base64.b64decode(infoField.firstChild.nodeValue)		
	return infoField.firstChild.nodeValue
for account in accounts:
	try:
		log("Checking %s for spam" % account.getAttribute("id"))

		# Connect to the server and login
		if getAccountInfo(account, "use") == "pop":
			pop = poplib.POP3(getAccountInfo(account, "host"))
			pop.user(getAccountInfo(account, "username"))
			pop.pass_(getAccountInfo(account, "password"))
		elif getAccountInfo(account, "use") == "apop":
			pop = poplib.POP3(getAccountInfo(account, "host"))
			pop.apop(getAccountInfo(account, "username"), getAccountInfo(account, "password"))
		elif getAccountInfo(account, "use") == "ssl":
			pop = poplib.POP3_SSL(getAccountInfo(account, "host"))
			pop.user(getAccountInfo(account, "username"))
			pop.pass_(getAccountInfo(account, "password"))

		# Check each message
		for msgID in range(1, len(pop.list()[1]) + 1):
			try:
				messageIp = False
				messageSubject = ""
				messageFrom = ""
	
				# Extract headers
				for headerLine in pop.top(msgID, 100)[1]:
					ip = re.search("Received:.+[^0-9]([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})", headerLine)
					if ip != None and messageIp == False:
						messageIp = ip.group(1)
					subject = re.search("Subject: (.+)", headerLine)
					if subject != None:
						messageSubject = email.Header.decode_header(subject.group(1))[0][0]
					mfrom = re.search("From: (.+)", headerLine)
					if mfrom != None:
						messageFrom = email.Header.decode_header(mfrom.group(1))[0][0]
					if headerLine == "": break
	
				# Assume that the message does not contain spam
				noSpam = True
	
				# Check keywords
				for match, keyword in keywords:
					if match == "sender":
						matchAgainst = messageFrom
					elif match == "subject":
						matchAgainst = messageSubject
					else:
						print "Error: I don't know match type %s" % match
						sys.exit(1)
					
					if re.search(keyword, matchAgainst, re.I) is not None:
						# This is spam, delete message
						log(" Message '%s' from '%s' is spam, matched against %s" % (messageSubject, messageFrom, keyword), 2)
						if deleteMessages:
							pop.dele(msgID)
						noSpam = False
						break
				if not noSpam:
					continue
	
				# If there is no IP in the header, skip this message
				if messageIp == False:
					log("Message #%d could not be scanned because of lacking an IP in the Received header")
					continue
				
				# Reverse the ip
				messageIp = string.join([ part + "." for part in messageIp.split(".").__reversed__() ], "")
	
				# Check the RBLs for this IP
				# To check an RBL yourself, do the following:
				#  - Reverse the sender's ip (see above)
				#  - Resolve the domainname <reversedip>.<rbldomain>
				#   - If you receive an answer, the IP is blacklisted
				for rbl in rbls:
					try:
						socket.gethostbyname("%s%s" % (messageIp, rbl))
						log(" Message '%s' from '%s' is spam, reported by %s" % (messageSubject, messageFrom, rbl), 2)
						noSpam = False
						break
					except(socket.gaierror):
						pass
				if noSpam == True:
					# This is not spam
					log(" Message '%s' from '%s' is not spam" % (messageSubject, messageFrom))
				else:
					# This is spam, delete message
					if deleteMessages:
						pop.dele(msgID)
			except:
				# An error occured
				log(" An error occured while processing mail #%d of account %s: %s" % (msgID, account.getAttribute("id"), sys.exc_info()[1]), 2)
				#import traceback
				#traceback.print_tb(sys.exc_info()[2], 2)
		pop.quit()
	except:
		# An error occured
		log(" An error occured while processing account %s: %s" % (account.getAttribute("id"), sys.exc_info()[1]), 2)
